<script setup lang="tsx">
import { Form, FormSchema } from '@/components/Form'
import { useForm } from '@/hooks/web/useForm'
import { PropType, reactive, watch } from 'vue'
import { useValidator } from '@/hooks/web/useValidator'

const { required } = useValidator()

const props = defineProps({
  currentRow: {
    type: Object as PropType<any>,
    default: () => null
  },
  actionType: {
    type: String,
    default: 'add'
  }
})

const { formRegister, formMethods } = useForm()
const { setValues, getFormData, getElFormExpose } = formMethods

const formSchema = reactive<FormSchema[]>([
  {
    field: 'pkid',
    label: '主键',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'filename',
    label: '文件名',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'documentcontent',
    label: '文档内容',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'createdate',
    label: '创建日期',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'createuser',
    label: '创建者',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'status',
    label: '状态',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'attribute1',
    label: '时间',
    component: 'DatePicker',
    componentProps: {
      type: 'daterange'
    },
  },
  {
    field: 'attribute2',
    label: '附件名',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'uploadid',
    label: '附件id',
    component: 'Input',
    componentProps: {
      
    },
  }
])

const rules = reactive({
  
})

const submit = async () => {
  const elForm = await getElFormExpose()
  const valid = await elForm?.validate().catch((err) => {
    console.log(err)
  })
  if (valid) {
    const formData = await getFormData()
    return formData
  }
}

watch(
  () => props.currentRow,
  (currentRow) => {
    if (!currentRow) return
    setValues(currentRow)
  },
  {
    deep: true,
    immediate: true
  }
)

defineExpose({
  submit
})
</script>

<template>
  <Form :rules="rules" @register="formRegister" :schema="formSchema" />
</template>

